# -*- coding: utf-8 -*-
"""python-introduction-9-3-2019.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1u-UqpvbsdH4CyncvFRyYua5xUgwWBWit

## Python is dynamic programming language
"""

x = 1
print(type(x)) # integer

x = 1.1
print(type(x)) # float / double

x = 'husein'
print(type(x)) # string

"""## basic arithmetic"""

1 + 1 # plus

2 - 3 # minus

2 / 5 # division

2 * 3 # multiply

2 ** 3 # power

2 // 5 # floor division

"""## List

Python doesnt have an Array, but Python got list. List is an array, but heterogenous, means, it can accept any types of variables, while Array, is homogeneous.

`Homogeneous` = if we defined an integer array, it only able to accept integer
"""

x = [1, 1.1, 'husein']
x

"""#### you can index the list"""

x[0]

x[1]

x[-1] # means, first last element

x[0] = 10
x

"""## Tuple

While List is mutable, tuple same like a list, but immutable. Once we defined it, we cannot override the value.
"""

x = [1, 1.1, 'husein'] # list
y = (1, 1.1, 'husein') # tuple

# a list can override
x[0] = 10

y[0] = 10

"""## Dictionary

A mapping system,

```python

{     <key>     :    <value>     }
```
"""

x = {'food':'nasi lemak','drink':'ais kosong'}

x['food']

# to get list of keys
x.keys()

# to get list of values
x.values()

# what happened if you want to index like normal list
x[0]

"""## set

In Python, we can do set theory
"""

x = {1,2,3,4,5,6,7,8}
y = {5,6,7,8,9,10,11,12}
# do not confused with set and dictionary

# set always unique
z = {1,1,1,1,1,2}
z

x.union(y) # union

x.intersection(y) # intersection

x.difference(y)

x.difference(y) != y.difference(x)

x.symmetric_difference(y)

x.symmetric_difference(y) == y.symmetric_difference(x)

"""## If-elif-else statement"""

# this is javascript / java / c
# if(statement) {
# 1.do something
#             2. do something
# }

# in Python, spacing is important
# if statement:
#   1. do something
#   2. do something

x = 10
if x < 3:
  print('x is less than 3')
elif x < 5:
  print('x is less than 5')
else:
  print('x is bigger than 5')

"""## Loop statement"""

# while loop

x = 10
while x > 0:
  print(x)
  x -= 1 # in python, we dont have x--, --x

# for loop

for i in range(10):
  print(i)

"""```python
range(  <start> ,   <end>,    <skip>)
```
"""

for i in range(2, 20, 3):
  print(i)

# we can reverse by using `reversed` statement

for i in reversed(range(2, 20, 3)):
  print(i)

"""## membership test"""

x = [1,2,3,4,5]

1 in x

10 in x

10 not in x

not 10 not in x

# can do for dictionary
x = {'food':'nasi lemak','drink':'ais kosong'}

# membership test only check for keys
'food' in x

'nasi lemak' in x

"""## slicing

python is multi paradigm programming language, slicing comes from functional programming language
"""

x = [1,2,3,4,5,6,7,8,9,10]

# i want from second index until fifth index (not included)

x[1 : 4]

"""```python
x [<start>       :         <end not included>]
```
"""

# i want from fifth last element, until the end

x[-5:]

# we can reverse a list using slicing

x[  :  :  -1]

"""```python
x [<start>       :         <end not included>   :     <skip value>]
```
"""

x[ : : 2]

x[ : : -2] # reversed and skipped by 2

"""## comprehension"""

x = []
for i in range(10):
  x.append(i)
x

x = [i for i in range(10)]
x

x = []
for i in range(10):
  for k in range(i):
    x.append(k)
len(x)

x = [k for i in range(10) for k in range(i)]
len(x)

"""```python
for a in b:
  for c in a:
    for d in c:
      for e in d:
        e
```

equal to,
```python
e for a in b for c in a for d in c for e in d
```

## membership speed
"""

# generate a list size 100 million
x = [i for i in range(100000000)]

"""%%time
9999999 in x
"""

x_set = set(x)

"""%%time
9999999 in x_set
"""

